/*
 * WebApiSegura Token JWT XrmAPI
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;
import io.swagger.client.BuildParameters;


import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.CTaskAttributes;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TaskApi {
    private ApiClient apiClient;
	static final String AUTH_TEXT="Authorization";
	static final String ACCEPTTEXT="Accept";
	static final String CONTENTTYPE="Content-Type";
	static final String APIMETHOD="/api/task/";
	
	static final String APPJSON="application/json";
	static final String TEXTJSON="text/json";
	static final String TEXT_XML="text/xml";
	static final String URLENCODE="application/x-www-form-urlencoded";
	
    public TaskApi() {
        this(Configuration.getDefaultApiClient());
    }

    public TaskApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

   
  


 /**
     * Build call for taskDelete
     * @param id  (required)
     * @param statecode  (optional)
     * @param statuscode  (optional)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call taskDeleteCall(String id, String statecode, String statuscode, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody2 = null;

        
        String localVarPath2 = APIMETHOD + "{id}"
            .replace("{" + "id" + "}", apiClient.escapeString(id));

        List<Pair> localVarQueryParams2 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams2 = new ArrayList<>();
        if (statecode != null){
			localVarQueryParams2.addAll(apiClient.parameterToPair("statecode", statecode));
		}
        if (statuscode != null){
			localVarQueryParams2.addAll(apiClient.parameterToPair("statuscode", statuscode));
		}

        Map<String, String> localVarHeaderParams2 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams2.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams2 = new HashMap<>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams2.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams2.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames2 = new String[] {  };
        BuildParameters buildParameters2=new BuildParameters();
			buildParameters2.setPath(localVarPath2);
			buildParameters2.setMethod("DELETE");
			buildParameters2.setQueryParams(localVarQueryParams2);
			buildParameters2.setCollectionQueryParams(localVarCollectionQueryParams2);
			buildParameters2.setBody(localVarPostBody2);
			buildParameters2.setHeaderParams(localVarHeaderParams2);
			buildParameters2.setFormParams(localVarFormParams2);
			buildParameters2.setAuthNames(localVarAuthNames2);
			buildParameters2.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters2);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call taskDeleteValidateBeforeCall(String id, String statecode, String statuscode, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling taskDelete(Async)");
        }
        

        return taskDeleteCall(id, statecode, statuscode, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param id  (required)
     * @param statecode  (optional)
     * @param statuscode  (optional)
     * @param authorization JWT Token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void taskDelete(String id, String statecode, String statuscode, String authorization) throws ApiException {
        taskDeleteWithHttpInfo(id, statecode, statuscode, authorization);
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param statecode  (optional)
     * @param statuscode  (optional)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> taskDeleteWithHttpInfo(String id, String statecode, String statuscode, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = taskDeleteValidateBeforeCall(id, statecode, statuscode, authorization, null, null);
        return apiClient.execute(call);
    }

  /**
     * Build call for taskGet
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call taskGetCall(Integer index, Integer limit, String q, String orderby, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody3 = null;

        
        String localVarPath3 = APIMETHOD + "get";

        List<Pair> localVarQueryParams3 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams3 = new ArrayList<>();
        if (index != null){
			localVarQueryParams3.addAll(apiClient.parameterToPair("index", index));
		}
        if (limit != null){
			localVarQueryParams3.addAll(apiClient.parameterToPair("limit", limit));
		}
        if (q != null){
			localVarQueryParams3.addAll(apiClient.parameterToPair("q", q));
		}
        if (orderby != null){
			localVarQueryParams3.addAll(apiClient.parameterToPair("orderby", orderby));
			
		}
       
			localVarQueryParams3.addAll(apiClient.parameterToPair("order", ""));
		
        
			localVarQueryParams3.addAll(apiClient.parameterToPair("fields", ""));
		
       
			localVarQueryParams3.addAll(apiClient.parameterToPair("filters", ""));
		

        Map<String, String> localVarHeaderParams3 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams3.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams3 = new HashMap<>();

        final String[] localVarAccepts3 = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept3 = apiClient.selectHeaderAccept(localVarAccepts3);
        if (localVarAccept3 != null) localVarHeaderParams3.put(ACCEPTTEXT, localVarAccept3);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType3 = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams3.put(CONTENTTYPE, localVarContentType3);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames3 = new String[] {  };
        BuildParameters buildParameters3=new BuildParameters();
			buildParameters3.setPath(localVarPath3);
			buildParameters3.setMethod("GET");
			buildParameters3.setQueryParams(localVarQueryParams3);
			buildParameters3.setCollectionQueryParams(localVarCollectionQueryParams3);
			buildParameters3.setBody(localVarPostBody3);
			buildParameters3.setHeaderParams(localVarHeaderParams3);
			buildParameters3.setFormParams(localVarFormParams3);
			buildParameters3.setAuthNames(localVarAuthNames3);
			buildParameters3.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters3);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call taskGetValidateBeforeCall(Integer index, Integer limit, String q, String orderby, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        return taskGetCall(index, limit, q, orderby,  authorization, progressListener, progressRequestListener);       
    }

    /**
     * 
     * 
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object taskGet(Integer index, Integer limit, String q, String orderby, String authorization) throws ApiException {
        ApiResponse<Object> resp = taskGetWithHttpInfo(index, limit, q, orderby,  authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> taskGetWithHttpInfo(Integer index, Integer limit, String q, String orderby, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = taskGetValidateBeforeCall(index, limit, q, orderby, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

  /**
     * Build call for taskGetCatalogs
     * @param catalogs  (optional)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call taskGetCatalogsCall(String catalogs, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody4 = null;

        
        String localVarPath4 = APIMETHOD + "getcatalogs";

        List<Pair> localVarQueryParams4 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams4 = new ArrayList<>();
        if (catalogs != null){
			localVarQueryParams4.addAll(apiClient.parameterToPair("catalogs", catalogs));
		}

        Map<String, String> localVarHeaderParams4 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams4.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams4 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams4.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams4.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames4 = new String[] {  };
        BuildParameters buildParameters4=new BuildParameters();
			buildParameters4.setPath(localVarPath4);
			buildParameters4.setMethod("GET");
			buildParameters4.setQueryParams(localVarQueryParams4);
			buildParameters4.setCollectionQueryParams(localVarCollectionQueryParams4);
			buildParameters4.setBody(localVarPostBody4);
			buildParameters4.setHeaderParams(localVarHeaderParams4);
			buildParameters4.setFormParams(localVarFormParams4);
			buildParameters4.setAuthNames(localVarAuthNames4);
			buildParameters4.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters4);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call taskGetCatalogsValidateBeforeCall(String catalogs, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        return taskGetCatalogsCall(catalogs, authorization, progressListener, progressRequestListener);        

    }

    /**
     * 
     * 
     * @param catalogs  (optional)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object taskGetCatalogs(String catalogs, String authorization) throws ApiException {
        ApiResponse<Object> resp = taskGetCatalogsWithHttpInfo(catalogs, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param catalogs  (optional)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> taskGetCatalogsWithHttpInfo(String catalogs, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = taskGetCatalogsValidateBeforeCall(catalogs, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }
  /**
     * Build call for taskGet0
     * @param id  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call taskGet0Call(String id, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody5 = null;

        
        String localVarPath5 = APIMETHOD + "{id}"
            .replace("{" + "id" + "}", apiClient.escapeString(id));

        List<Pair> localVarQueryParams5 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams5 = new ArrayList<>();

        Map<String, String> localVarHeaderParams5 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams5.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams5 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams5.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams5.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames5 = new String[] {  };
		//Parametros para webservice 5
        BuildParameters buildParameters5=new BuildParameters();
			buildParameters5.setPath(localVarPath5);
			buildParameters5.setMethod("GET");
			buildParameters5.setQueryParams(localVarQueryParams5);
			buildParameters5.setCollectionQueryParams(localVarCollectionQueryParams5);
			buildParameters5.setBody(localVarPostBody5);
			buildParameters5.setHeaderParams(localVarHeaderParams5);
			buildParameters5.setFormParams(localVarFormParams5);
			buildParameters5.setAuthNames(localVarAuthNames5);
			buildParameters5.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters5);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call taskGet0ValidateBeforeCall(String id, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling taskGet0(Async)");
        }
        

        return taskGet0Call(id, authorization, progressListener, progressRequestListener);        

    }

    /**
     * 
     * 
     * @param id  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object taskGet0(String id, String authorization) throws ApiException {
        ApiResponse<Object> resp = taskGet0WithHttpInfo(id, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> taskGet0WithHttpInfo(String id, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = taskGet0ValidateBeforeCall(id, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }
   /**
     * Build call for taskPost
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call taskPostCall(CTaskAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody6 = value;

        
        String localVarPath6 = APIMETHOD;

        List<Pair> localVarQueryParams6 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams6 = new ArrayList<>();

        Map<String, String> localVarHeaderParams6 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams6.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams6 = new HashMap<>();

        final String[] localVarAccepts6 = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept6 = apiClient.selectHeaderAccept(localVarAccepts6);
        if (localVarAccept6 != null) localVarHeaderParams6.put(ACCEPTTEXT, localVarAccept6);

        final String[] localVarContentTypes6 = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes6);
        localVarHeaderParams6.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames6 = new String[] {  };
        BuildParameters buildParameters6=new BuildParameters();
			buildParameters6.setPath(localVarPath6);
			buildParameters6.setMethod("POST");
			buildParameters6.setQueryParams(localVarQueryParams6);
			buildParameters6.setCollectionQueryParams(localVarCollectionQueryParams6);
			buildParameters6.setBody(localVarPostBody6);
			buildParameters6.setHeaderParams(localVarHeaderParams6);
			buildParameters6.setFormParams(localVarFormParams6);
			buildParameters6.setAuthNames(localVarAuthNames6);
			buildParameters6.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters6);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call taskPostValidateBeforeCall(CTaskAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (value == null) {
            throw new ApiException("Missing the required parameter 'value' when calling taskPost(Async)");
        }
        

        return taskPostCall(value, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object taskPost(CTaskAttributes value, String authorization) throws ApiException {
        ApiResponse<Object> resp = taskPostWithHttpInfo(value, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> taskPostWithHttpInfo(CTaskAttributes value, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = taskPostValidateBeforeCall(value, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }
   /**
     * Build call for taskPut
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call taskPutCall(String id, CTaskAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody7 = value;

        
        String localVarPath7 = APIMETHOD + "{id}"
            .replace("{" + "id" + "}", apiClient.escapeString(id));

        List<Pair> localVarQueryParams7 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams7 = new ArrayList<>();

        Map<String, String> localVarHeaderParams7 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams7.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams7 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams7.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams7.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames7 = new String[] {  };
        BuildParameters buildParameters7=new BuildParameters();
			buildParameters7.setPath(localVarPath7);
			buildParameters7.setMethod("PUT");
			buildParameters7.setQueryParams(localVarQueryParams7);
			buildParameters7.setCollectionQueryParams(localVarCollectionQueryParams7);
			buildParameters7.setBody(localVarPostBody7);
			buildParameters7.setHeaderParams(localVarHeaderParams7);
			buildParameters7.setFormParams(localVarFormParams7);
			buildParameters7.setAuthNames(localVarAuthNames7);
			buildParameters7.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters7);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call taskPutValidateBeforeCall(String id, CTaskAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling taskPut(Async)");
        }
        
        
        if (value == null) {
            throw new ApiException("Missing the required parameter 'value' when calling taskPut(Async)");
        }
        

        return taskPutCall(id, value, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object taskPut(String id, CTaskAttributes value, String authorization) throws ApiException {
        ApiResponse<Object> resp = taskPutWithHttpInfo(id, value, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> taskPutWithHttpInfo(String id, CTaskAttributes value, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = taskPutValidateBeforeCall(id, value, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

}
